Index: tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/editors/EditionPanel.java
===================================================================
--- tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/editors/EditionPanel.java	(revision 0)
+++ tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/editors/EditionPanel.java	(revision 653)
@@ -0,0 +1,1234 @@
+package org.txm.synopticedition.rcp.editors;
+
+import java.io.File;
+import java.net.URL;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.List;
+import java.util.Set;
+import java.util.logging.Level;
+
+import org.eclipse.core.commands.Command;
+import org.eclipse.core.commands.ExecutionException;
+import org.eclipse.core.commands.IParameter;
+import org.eclipse.core.commands.NotEnabledException;
+import org.eclipse.core.commands.NotHandledException;
+import org.eclipse.core.commands.Parameterization;
+import org.eclipse.core.commands.ParameterizedCommand;
+import org.eclipse.core.commands.common.NotDefinedException;
+import org.eclipse.core.runtime.FileLocator;
+import org.eclipse.core.runtime.Platform;
+import org.eclipse.jface.action.MenuManager;
+import org.eclipse.jface.text.ITextSelection;
+import org.eclipse.jface.viewers.ISelection;
+import org.eclipse.jface.viewers.ISelectionChangedListener;
+import org.eclipse.jface.viewers.ISelectionProvider;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.browser.Browser;
+import org.eclipse.swt.browser.BrowserFunction;
+import org.eclipse.swt.browser.ProgressEvent;
+import org.eclipse.swt.browser.ProgressListener;
+import org.eclipse.swt.events.MenuEvent;
+import org.eclipse.swt.events.MenuListener;
+import org.eclipse.swt.events.SelectionEvent;
+import org.eclipse.swt.events.SelectionListener;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Menu;
+import org.eclipse.swt.widgets.MenuItem;
+import org.eclipse.ui.IWorkbenchWindow;
+import org.eclipse.ui.PlatformUI;
+import org.eclipse.ui.commands.ICommandService;
+import org.eclipse.ui.handlers.IHandlerService;
+import org.eclipse.ui.internal.browser.BrowserViewer;
+import org.osgi.framework.Bundle;
+import org.txm.core.preferences.TXMPreferences;
+import org.txm.objects.Corpus;
+import org.txm.objects.Edition;
+import org.txm.objects.Page;
+import org.txm.objects.Text;
+import org.txm.rcp.StatusLine;
+import org.txm.rcp.utils.IOClipboard;
+import org.txm.synopticedition.rcp.messages.SynopticEditionUIMessages;
+import org.txm.synopticedition.rcp.preferences.SynopticEditionPreferencePage;
+import org.txm.synopticedition.rcp.preferences.SynopticEditionPreferences;
+import org.txm.utils.io.IOUtils;
+import org.txm.utils.logger.Log;
+
+public class EditionPanel extends BrowserViewer implements ISelectionProvider {
+
+	public static class RGBA {
+		public int r=0, g=0, b=0;
+		public float a = 1f;
+		public RGBA(int r, int g, int b) {
+			this.r =r;this.g=g; this.b =b;
+		}
+		public RGBA(String rgb) {
+			String[] split = rgb.split(",");
+			try{this.r =Integer.parseInt(split[0]);}catch(Exception e){}
+			try{this.g =Integer.parseInt(split[1]);}catch(Exception e){}
+			try{this.b =Integer.parseInt(split[2]);}catch(Exception e){}
+		}
+		public RGBA(String rgb, float a) {
+			String[] split = rgb.split(",");
+			try{this.r =Integer.parseInt(split[0]);}catch(Exception e){}
+			try{this.g =Integer.parseInt(split[1]);}catch(Exception e){}
+			try{this.b =Integer.parseInt(split[2]);}catch(Exception e){}
+			this.a = a;
+		}
+		public RGBA(int r, int g, int b, float a) {
+			this.r =r;this.g=g; this.b =b;this.a =a;
+		}
+
+		public String toString() {return "{"+r+", "+g+","+b+", "+a+"}";}
+	}
+
+	private ProgressListener progresslistener;
+	//	private List<String> wordids;
+	//	private List<String> lineids;
+	/** The edition. */
+	Text currentText;
+	Edition currentEdition;
+	Page currentPage;
+	protected SynopticEditionEditor synopticEditionEditor;
+	private ISelectionProvider selProvider;
+	private MenuManager menuManager;
+
+	private HashSet<int[]> highlightedAreas = null;
+
+	//HashMap<String, ArrayList<RGBA>> highlightedColorSpans = new HashMap<String, ArrayList<RGBA>>(); // background color
+
+	HashMap<String, ArrayList<RGBA>> highlightedColorPerWordIDS = new HashMap<String, ArrayList<RGBA>>(); // background color
+	public static final String STYLE_NORMAL = "normal";
+	public static final String STYLE_ITALIC = "italic";
+	public static final String STYLE_OBLIQUE = "oblique";
+	HashMap<String, String> fontStylePerWordIDS = new HashMap<String, String>();
+	public static final String WEIGHT_NORMAL = "normal";
+	public static final String WEIGHT_BOLD = "bold";
+	HashMap<String, String> fontWeightPerWordIDS = new HashMap<String, String>();
+	HashMap<String, ArrayList<RGBA>> fontColorPerWordIDS = new HashMap<String, ArrayList<RGBA>>();
+	public static final String SIZE_SMALL = "small";
+	public static final String SIZE_MEDIUM = "medium";
+	public static final String SIZE_LARGE = "larger";
+	public static final String SIZE_SMALLER = "smaller";
+	public static final String SIZE_LARGER = "larger";
+	HashMap<String, String> fontSizePerWordIDS = new HashMap<String, String>();
+	public static final String FAMILLY_TIMES = "\"Times New Roman\", Times";
+	public static final String FAMILLY_ARIAL = "Arial";
+	public static final String FAMILLY_COURIER = "\"Courier New\", Courier";
+	HashMap<String, String> fontFamillyPerWordIDS = new HashMap<String, String>();
+	public static final String VARIANT_NORMAL = "normal";
+	public static final String VARIANT_SMALLCAPS = "small-caps";
+	HashMap<String, String> fontVariantPerWordIDS = new HashMap<String, String>();
+	String focusedWordID = null;
+
+	public static final String highlightscript = "try { var elt = document.getElementById(\"%s\");" + //$NON-NLS-1$ //$NON-NLS-2$
+			"elt.style.backgroundColor=\"rgb(%s,%s,%s)\";" + //$NON-NLS-1$
+			//"elt.style.paddingLeft=\"3px\";" + //$NON-NLS-1$
+			//"elt.style.paddingRight=\"3px\";" + //$NON-NLS-1$
+			//"elt.style.paddingTop=\"1px\";" + //$NON-NLS-1$
+			//"elt.style.paddingBottom=\"1px\";" + //$NON-NLS-1$
+			"} catch (e) { };"; //$NON-NLS-1$
+	public static final String highlightscriptRuleFast = "sheet.insertRule(\"#%s {background-color:rgba(%s,%s,%s,%s);}\", 0);";
+	public static final String colorscriptRuleFast = "sheet.insertRule(\"#%s {color:rgba(%s,%s,%s,%s);}\", 0);";
+	public static final String sizescriptRuleFast = "sheet.insertRule(\"#%s {font-size:%s;}\", 0);";
+	public static final String stylescriptRuleFast = "sheet.insertRule(\"#%s {font-style:%s;}\", 0);";
+	public static final String variantscriptRuleFast = "sheet.insertRule(\"#%s {font-variant:%s;}\", 0);";
+	public static final String famillyscriptRuleFast = "sheet.insertRule(\"#%s {font-familly:%s;}\", 0);";
+	public static final String weightscriptRuleFast = "sheet.insertRule(\"#%s {font-weight:%s;}\", 0);";
+
+	public static final String highlightscriptRule = "sheet.insertRule(\"span[id=\\\"%s\\\"] {background-color:rgba(%s,%s,%s,%s); }\", 0);";
+
+	public static final String clearhighlightscript = "try { var elt = document.getElementById(\"%s\"); elt.style.backgroundColor=\"white\";elt.style.fontWeight=\"\";" + //$NON-NLS-1$
+			"} catch (e) { };"; //$NON-NLS-1$
+
+	public String functions = 
+			""//"alert(\"loading functions\");"
+					+"\nfunction getNodeText(node) {"
+					+"\n	if (typeof node == 'string') return node;"
+					+"\n	else if (typeof  node.innerText != 'undefined') return node.innerText;"
+					+"\n	else if (typeof  node.InnerText != 'undefined') return node.InnerText;"
+					+"\n	else if (typeof  node.textContent != 'undefined') return node.textContent;"
+					+"\n	else return null;"
+					+"\n}"
+					+"\nfunction txmGetParent(node) {"
+					+"\n	if (typeof  node.parentNode != 'undefined') return node.parentNode;"
+					+"\n	else return null;"
+					+"\n}"
+					+"\nfunction txmGetChildren(node) {"
+					+"\n	if (typeof node == 'string') return 'STRING HTML';"
+					+"\n	else if (typeof  node.children != 'undefined') return node.children;"
+					+"\n	else if (typeof  node.ChildNodes != 'undefined') return node.ChildNodes;"
+					+"\n	else if (typeof  node.childNodes != 'undefined') return node.childNodes;"
+					+"\n	else return null;"
+					+"\n}"
+					+"\nfunction txmGetSelection() {"
+					+"\n	if (typeof window.getSelection != 'undefined') {return window.getSelection();}"
+					+"\n	else if (typeof document.selection != 'undefined') { return document.selection;}"
+					+"\n	else return 'NO SELECTION';"
+					+"\n}"
+					+"\nfunction txmGetRangeSize(selection) {"
+					+"\n	if (typeof selection.rangeCount != 'undefined') {return selection.rangeCount;}"
+					+"\n	else if (typeof selection.createRangeCollection != 'undefined') { return selection.createRangeCollection().length();} // IE5 has no multiple selection"
+					+"\n}"
+					+"\nfunction txmGetRange(selection, i) {"
+					+"\n	if (typeof selection.getRangeAt != 'undefined') {return selection.getRangeAt(i);}"
+					+"\n	else if (typeof selection.createRangeCollection != 'undefined') {return selection.createRangeCollection().item(i);}" // IE > IE5 
+					+"\n	else if (typeof selection.createRange != 'undefined') { return selection.createRange();} // IE5 has no multiple selection"
+					+"\n	else return 'NO RANGE';"
+					+"\n}"
+					+"\nfunction txmGetParentElementRange(range) {"
+					+"\n	if (typeof range.parentElement != 'undefined') {return range.parentElement();}"
+					+"\n	else if (typeof range.startContainer != 'undefined') { return range.startContainer.parentNode;}"
+					+"\n	else return 'NO PARENT';"
+					+"\n}"
+					+"\nfunction txmGetFragment(range) {"
+					+"\n	if (typeof range.cloneContents != 'undefined') { return range.cloneContents();}"
+					+"\n	else if (typeof range.htmlText != 'undefined') {var node = document.createElement('sel'); node.innerHTML = range.htmlText; 		return node;"
+					+"\n	} else return 'NO FRAG';"
+					+"\n}"
+					+"\nfunction txmGetTagName(node) {"
+					+"\n	if (typeof node.tagName != 'undefined') {return node.tagName;}"
+					+"\n	else if (typeof node.nodeName != 'undefined') { return node.nodeName;}"
+					+"\n	else if (typeof node.name != 'undefined') { return node.name;}"
+					+"\n	else return 'NO TAGNAME';"
+					+"\n}"
+					+"\nfunction findSpans(children, all) {"
+					+"\n    for (var i = 0 ; i < children.length ; i++) {"
+					+"\n    	var node = children.item(i);"
+					+"\n		if (node.nodeType == 1) {"
+					+"\n    	var id = node.getAttribute('id');"
+					+"\n       		if (node.tagName == 'SPAN' && id != null && id.indexOf('w_') == 0 && getNodeText(node).length > 0) {"
+					+"\n            	if (id != null) all.push(id);"
+					+"\n        	} else {"
+					+"\n        		findSpans(txmGetChildren(node), all)"
+					+"\n        	}"
+					+"\n		}"
+					+"\n	}"
+					+"\n}"
+					+"\nfunction findIdsInString(str, all) {"
+					+"\n    for (var i = 0 ; i < children.length ; i++) {"
+					+"\n    	var node = children.item(i);"
+					+"\n		if (node.nodeType == 1) {"
+					+"\n    	var id = node.getAttribute('id');"
+					+"\n       		if (node.tagName == 'SPAN' && id != null && id.indexOf('w_') == 0 && getNodeText(node).length > 0) {"
+					+"\n            	if (id != null) all.push(id);"
+					+"\n        	} else {"
+					+"\n        		findSpans(txmGetChildren(node), all)"
+					+"\n        	}"
+					+"\n		}"
+					+"\n	}"
+					+"\n}"
+					+"\nfunction get_type(thing){if(thing===null)return \"[object Null]\";  return Object.prototype.toString.call(thing);}\n"
+					+"\nfunction getDetailedObject(inputObject) { var detailedObject = {}; var properties; \n   do {        properties = Object.getOwnPropertyNames( inputObject );        for (var o in properties) {detailedObject[properties[o]] = inputObject[properties[o]];}} while ( inputObject = Object.getPrototypeOf(inputObject) );return detailedObject;}\n"
+					+"\nvar sheet = null;"
+					+"\ntry{"
+					+"\n	var style = document.createElement(\"style\");"
+					+"\n	style.appendChild(document.createTextNode(\"\"));"//webkit hack
+					+"\n	document.head.appendChild(style);"
+					+"\n	sheet = style.sheet;"
+					+"\n} catch(e) {sheet='error'}"
+					+"\ntry{"
+					+"\n" // define scrollIntoViewIfNeeded if absent
+					+"\nif (!Element.prototype.scrollIntoViewIfNeeded) {"
+					+"\n	Element.prototype.scrollIntoViewIfNeeded = function (centerIfNeeded) {"
+					+"\n		centerIfNeeded = arguments.length === 0 ? true : !!centerIfNeeded;"
+					+"\n		var parent = this.parentNode,"
+					+"\n		parentComputedStyle = window.getComputedStyle(parent, null),"
+					+"\n		parentBorderTopWidth = parseInt(parentComputedStyle.getPropertyValue('border-top-width')),"
+					+"\n		parentBorderLeftWidth = parseInt(parentComputedStyle.getPropertyValue('border-left-width')),"
+					+"\n		overTop = this.offsetTop - parent.offsetTop < parent.scrollTop,"
+					+"\n		overBottom = (this.offsetTop - parent.offsetTop + this.clientHeight - parentBorderTopWidth) > (parent.scrollTop + parent.clientHeight),"
+					+"\n		overLeft = this.offsetLeft - parent.offsetLeft < parent.scrollLeft,"
+					+"\n		overRight = (this.offsetLeft - parent.offsetLeft + this.clientWidth - parentBorderLeftWidth) > (parent.scrollLeft + parent.clientWidth),"
+					+"\n		alignWithTop = overTop && !overBottom;"
+					+"\n		if ((overTop || overBottom) && centerIfNeeded) {"
+					+"\n			parent.scrollTop = this.offsetTop - parent.offsetTop - parent.clientHeight / 2 - parentBorderTopWidth + this.clientHeight / 2;"
+					+"\n		}"
+					+"\n		if ((overLeft || overRight) && centerIfNeeded) {"
+					+"\n			parent.scrollLeft = this.offsetLeft - parent.offsetLeft - parent.clientWidth / 2 - parentBorderLeftWidth + this.clientWidth / 2;"
+					+"\n		}"
+					+"\n		if ((overTop || overBottom || overLeft || overRight) && !centerIfNeeded) {"
+					+"\n			this.scrollIntoView(alignWithTop);"
+					+"\n		}"
+					+"\n	};"
+					+"\n}"
+					+"\n} catch(e) {Element.prototype.scrollIntoViewIfNeeded = Element.prototype.scrollIntoView}";
+	protected boolean fastWordHighLight = TXMPreferences.getBoolean(SynopticEditionPreferences.FAST_HIGHLIGHT, SynopticEditionPreferences.PREFERENCES_NODE);
+
+	public Object evaluate(String code) {
+		if (Log.getLevel().intValue() <= Level.FINEST.intValue()) System.out.println(code);
+		return getBrowser().evaluate(code);
+	}
+	public Object execute(String code) {
+		if (Log.getLevel().intValue() <= Level.FINEST.intValue()) System.out.println(code);
+		return getBrowser().execute(code);
+	}
+	public EditionPanel(SynopticEditionEditor synopticEditionEditor, Composite parent, int style, Edition edition) {
+		super(parent, style);
+		this.synopticEditionEditor = synopticEditionEditor;
+		this.currentEdition = edition;
+		this.currentText = currentEdition.getText();
+
+		File functionsFile = null;
+		try {
+
+			Bundle bundle = Platform.getBundle("SynopticEditorRCP");
+			URL fileURL = bundle.getEntry("res/js/functions.js");
+			URL r = FileLocator.resolve(fileURL);
+			Log.info("Load JS functions from: "+r);
+			functions = IOUtils.getText(r, "UTF-8");
+
+		} catch (Exception e) {
+			System.out.println("Error while reading "+functionsFile+": "+e.getLocalizedMessage());
+			Log.printStackTrace(e);
+		}
+
+		progresslistener = new ProgressListener() {
+
+			@Override
+			public void changed(ProgressEvent event) { }
+
+			@Override
+			public void completed(ProgressEvent event) {
+				//				System.out.println("EditionPanel "+currentEdition.getName()+" reload "+getCurrentPage().getName());
+				Object rez = evaluate("return typeof sheet");
+				if ("undefined".equals(rez)) execute(functions); // build the sheet if not present in the HTML DOM
+
+				//System.out.println("highlight: "+highlightedColorPerWordIDS);
+				StringBuilder buffer = new StringBuilder();
+				//buffer.append("alert(\"\"+sheet);\n");
+				if (!fastWordHighLight) {
+					//					for (String wordid : highlightedColorPerWordIDS.keySet()) {
+					//						buffer.append(String.format(clearhighlightscript, wordid)+"\n");
+					//					}
+				} else {
+					buffer.append("try { while(sheet.cssRules.length > 0) sheet.deleteRule(0); } catch (e) {};\n"); // empty style
+				}
+
+				if (buffer.length() > 0) execute(buffer.toString());
+				buffer = new StringBuilder();
+
+				String firstWord = currentPage.getWordId();
+				Page nextPage = currentEdition.getNextPage(currentPage);
+				String lastWord = "w_999999999";
+				if (nextPage != null && currentPage != nextPage) lastWord = nextPage.getWordId();
+				//System.out.println("firstWord="+firstWord+" lastWord="+lastWord);
+				//int n = 0;
+				//long start = System.currentTimeMillis();
+				//System.out.println(highlightedColorPerWordIDS);
+				for (String wordid : highlightedColorPerWordIDS.keySet()) {
+					if (highlightedColorPerWordIDS.get(wordid).size() == 0) continue; // error
+
+					//if (!slowWordHighLight) { //TODO: this code must be replaced with word position instead of word id comparaison
+					if (Edition.isFirstGTthanSecond(wordid, firstWord) < 0) continue; // skip the word to highlight
+					if (Edition.isFirstGTthanSecond(lastWord, wordid) < 0) continue; // skip the word to highlight
+					//}
+					//n++;
+					RGBA composite = new RGBA(0,0,0,0f);
+					int size = highlightedColorPerWordIDS.get(wordid).size();
+
+					for (RGBA color : highlightedColorPerWordIDS.get(wordid)) {
+						composite.r += color.r;
+						composite.g += color.g;
+						composite.b += color.b;
+						composite.a += color.a;
+					}
+
+					composite.r /= size;
+					composite.g /= size;
+					composite.b /= size;
+
+					String s = null;
+					if (!fastWordHighLight) {
+						//s = String.format(highlightscriptRule, wordid, composite.r, composite.g, composite.b, composite.a);
+						s = "try { document.getElementById(\"" + wordid + "\").style.backgroundColor=\"rgba("+composite.r+","+composite.g+","+composite.b+","+composite.a+")\";" //$NON-NLS-1$
+								+ 
+								//								"elt.style.paddingLeft=\"3px\";" + //$NON-NLS-1$
+								//								"elt.style.paddingRight=\"3px\";" + //$NON-NLS-1$
+								//								"elt.style.paddingTop=\"1px\";" + //$NON-NLS-1$
+								//								"elt.style.paddingBottom=\"1px\";" + //$NON-NLS-1$
+								"} catch (e) { };"; //$NON-NLS-1$
+					} else {
+						//TODO: replace this line with the next one for TXM 0.7.9
+						s = String.format(highlightscriptRuleFast, wordid.replace(" ", "\\ "), composite.r, composite.g, composite.b, composite.a);
+						//						s = String.format(highlightscriptRuleFast, wordid, composite.r, composite.g, composite.b, composite.a);
+					}
+
+					buffer.append(s+"\n");
+				}
+
+				if (buffer.length() > 0) execute(buffer.toString());
+				buffer = new StringBuilder();
+
+				//				for (String wordidslist : highlightedColorSpans.keySet()) {
+				//					RGBA composite = new RGBA(0,0,0,0f);
+				//					int size = highlightedColorSpans.get(wordidslist).size();
+				//					
+				//					for (RGBA color : highlightedColorSpans.get(wordidslist)) {
+				//						composite.r += color.r;
+				//						composite.g += color.g;
+				//						composite.b += color.b;
+				//						composite.a += color.a;
+				//					}
+				//					
+				//					composite.r /= size;
+				//					composite.g /= size;
+				//					composite.b /= size;
+				//					
+				//					String cmd = "var l = "+wordidslist+";\n";
+				//					cmd += "wrap(l, \""+wordidslist+"\";\n";
+				//					buffer.append(cmd+"\n");
+				//				}
+
+				for (String wordid : fontColorPerWordIDS.keySet()) {
+					RGBA composite = new RGBA(0,0,0,0f);
+					int size = fontColorPerWordIDS.get(wordid).size();
+
+					for (RGBA color : fontColorPerWordIDS.get(wordid)) {
+						composite.r += color.r;
+						composite.g += color.g;
+						composite.b += color.b;
+						composite.a += color.a;
+					}
+
+					composite.r /= size;
+					composite.g /= size;
+					composite.b /= size;
+
+					String s = String.format(colorscriptRuleFast, wordid, composite.r, composite.g, composite.b, composite.a);
+					buffer.append(s+"\n");
+				}
+
+				if (buffer.length() > 0) execute(buffer.toString());
+				buffer = new StringBuilder();
+
+				for (String wordid : fontSizePerWordIDS.keySet()) {
+					String s = String.format(sizescriptRuleFast, wordid, fontSizePerWordIDS.get(wordid));
+					buffer.append(s+"\n");
+				}
+
+				for (String wordid : fontWeightPerWordIDS.keySet()) {
+					String s = null;
+					if (!fastWordHighLight) {
+						//s = String.format(highlightscriptRule, wordid, composite.r, composite.g, composite.b, composite.a);
+						s = "try { document.getElementById(\"" + wordid + "\").style.fontWeight=\""+fontWeightPerWordIDS.get(wordid)+"\";" //$NON-NLS-1$
+								+ 
+								//								"elt.style.paddingLeft=\"3px\";" + //$NON-NLS-1$
+								//								"elt.style.paddingRight=\"3px\";" + //$NON-NLS-1$
+								//								"elt.style.paddingTop=\"1px\";" + //$NON-NLS-1$
+								//								"elt.style.paddingBottom=\"1px\";" + //$NON-NLS-1$
+								"} catch (e) { };"; //$NON-NLS-1$
+						//s = String.format(highlightscriptRule, wordid, composite.r, composite.g, composite.b, composite.a);
+						//						s = "try { var elt = document.getElementById(\"" + wordid + "\");" + //$NON-NLS-1$ //$NON-NLS-2$
+						//								"elt.style.fontWeight=\""+fontWeightPerWordIDS.get(wordid)+"\";" + //$NON-NLS-1$
+						////								"elt.style.paddingLeft=\"3px\";" + //$NON-NLS-1$
+						////								"elt.style.paddingRight=\"3px\";" + //$NON-NLS-1$
+						////								"elt.style.paddingTop=\"1px\";" + //$NON-NLS-1$
+						////								"elt.style.paddingBottom=\"1px\";" + //$NON-NLS-1$
+						//								"} catch (e) { };"; //$NON-NLS-1$
+					} else {
+						s = String.format(weightscriptRuleFast, wordid, fontWeightPerWordIDS.get(wordid));
+					}
+					buffer.append(s+"\n");
+				}
+
+				for (String wordid : fontFamillyPerWordIDS.keySet()) {
+					String s = String.format(famillyscriptRuleFast, wordid, fontFamillyPerWordIDS.get(wordid));
+					buffer.append(s+"\n");
+				}
+
+				if (buffer.length() > 0) execute(buffer.toString());
+				buffer = new StringBuilder();
+
+				if (focusedWordID != null) {
+					//System.out.println("Focus on: "+focusedWordID);
+					String s = "try { showElementIfNeeded(document.getElementById(\"" + focusedWordID + "\")); } catch (e) {document.getElementById(\"" + focusedWordID + "\").scrollIntoView();};"; //$NON-NLS-1$ //$NON-NLS-2$
+					buffer.append(s+"\n");
+					focusedWordID = null; // focus one time
+				}
+
+				if (buffer.length() > 0) execute(buffer.toString());
+				buffer = new StringBuilder();
+
+				if (highlightedAreas != null) {
+					for (int[] pos : highlightedAreas ) {
+						if (pos == null || pos.length != 4) continue;
+						String s = "try {v.setFocusOn("+pos[0]+", "+pos[1]+", "+pos[2]+", "+pos[3]+");} catch (e) { };"; //$NON-NLS-1$
+						buffer.append(s+"\n");
+						break;// one word only for now
+					}
+				}
+
+				//System.out.println(buffer);
+				if (buffer.length() > 0) execute(buffer.toString());
+				//System.out.println("n="+n+" time="+(System.currentTimeMillis()-start));
+			}
+		};
+		getBrowser().addProgressListener(progresslistener);
+		new CommandLink (getBrowser());
+	}
+
+	/**
+	 * Bypass BrowserViewer restriction on the getBrowser method
+	 */
+	public Browser getBrowser() {
+		return super.getBrowser();
+	}
+
+	/**
+	 * Bypass BrowserViewer restriction on the getBrowser method
+	 */
+	public String getDOM() {
+		return "";//execute("return document.innerHTML";
+	}
+
+	public ISelectionProvider getSelectionProvider() {
+		return selProvider;
+	}
+
+	public void setHighlightWordsById(RGBA color, HashSet<String> wordids) {
+		for (String wordid : wordids) {
+			if (this.highlightedColorPerWordIDS.get(wordid) != null) {
+				removeHighlightWordsById(color, wordid);
+			}
+			ArrayList<RGBA> hs = new ArrayList<RGBA>();
+			this.highlightedColorPerWordIDS.put(wordid, hs);
+			hs.add(color);
+		}
+	}
+
+	public void addHighlightWordsById(RGBA color, String wordid) {
+		if (!this.highlightedColorPerWordIDS.containsKey(wordid)) {
+			this.highlightedColorPerWordIDS.put(wordid, new ArrayList<RGBA>());
+		}
+		this.highlightedColorPerWordIDS.get(wordid).add(color);
+	}
+
+	/**
+	 * Can be called to refresh the page word styles but only when the page is loaded
+	 */
+	public void updateWordStyles() {
+		progresslistener.completed(null);
+	}
+
+	public void addHighlightWordsById(RGBA color, Collection<String> wordids) {
+		for (String wordid : wordids) {
+			addHighlightWordsById(color, wordid);
+		}
+	}
+
+	public void removeHighlightWordsById(RGBA color, Collection<String> wordids) {
+		//System.out.println("Call removeHighlightWordsById: "+wordids+" color="+color);
+		StringBuffer buffer = new StringBuffer();
+		for (String wordid : wordids) {
+			removeHighlightWordsById(color, wordid);
+			if (!fastWordHighLight) {
+				buffer.append(String.format(clearhighlightscript, wordid)+"\n");
+			}
+		}
+
+		if (buffer.length() > 0) execute(buffer.toString());
+	}
+
+	public void removeHighlightWordsById(RGBA color, String wordid) {
+		if (highlightedColorPerWordIDS.get(wordid) == null) return; // nothing to do
+
+		//System.out.println("remove color="+color+" from id="+wordid);
+		this.highlightedColorPerWordIDS.get(wordid).remove(color);
+
+		if (this.highlightedColorPerWordIDS.get(wordid).size() == 0) {
+			this.highlightedColorPerWordIDS.remove(wordid);
+		}
+	}
+
+	/**
+	 * Open the page containing the word with ID=$line_wordid
+	 * @param line_wordid
+	 * @return true if the page changed
+	 */
+	public boolean backToText(Text text, String line_wordid) {
+
+		String name = currentEdition.getName();
+		Edition edition = text.getEdition(name);
+
+		if (edition == null) {
+			String s = SynopticEditionUIMessages.EditionPanel_0+text+SynopticEditionUIMessages.EditionPanel_5+name;
+			System.out.println(s);
+			StatusLine.setMessage(s);
+			Log.severe(s);
+		} else {
+			Page openedPage = edition.getPageForWordId(line_wordid);
+			if (openedPage != null && openedPage != currentPage) {
+				this.showPage(openedPage);
+				return true;
+			}
+		}
+		updateWordStyles(); // update styles if any new one
+		return false;
+	}
+
+	/**
+	 * First page.
+	 */
+	public void firstPage() {
+		// System.out.println(Messages.TxmBrowser_1+currentPage);
+		currentPage = currentEdition.getFirstPage();
+		currentText = currentEdition.getText();
+		if (currentPage == null) {
+			System.out.println(SynopticEditionUIMessages.EditionPanel_1+currentEdition.getName()+SynopticEditionUIMessages.EditionPanel_2+currentText.getName());
+		}
+
+		this.setURL(currentPage.toURL());
+
+		//page_label.setText(makePageLabel());
+	}
+
+	public void setURL(String url) {
+		super.setURL(url);
+	}
+
+	/**
+	 * Last page.
+	 */
+	public void lastPage() {
+		// System.out.println(Messages.TxmBrowser_2+currentPage);
+
+		if (currentPage != null && currentPage.getFile().equals(currentEdition.getLastPage()))
+			return;
+		currentPage = currentEdition.getLastPage();
+		currentText = currentEdition.getText();
+		this.setURL(currentPage.toURL());
+	}
+
+	/**
+	 * Previous page.
+	 */
+	public void previousPage() {
+		// System.out.println(Messages.TxmBrowser_3+currentPage);
+		if (currentPage != null) {
+			Page previous = currentEdition.getPreviousPage(currentPage);
+
+			if (previous == currentPage) {
+				previousText(true);
+			} else {
+				currentPage = previous;
+				this.setURL(currentPage.toURL());
+			}
+			currentText = currentEdition.getText();
+		} else
+			firstPage();
+		//page_label.setText(makePageLabel());
+	}
+
+
+
+	/**
+	 * Next page.
+	 */
+	public void nextPage() {
+		// System.out.println(Messages.TxmBrowser_4+currentPage);
+		if (currentPage != null) {
+			Page next = currentEdition.getNextPage(currentPage);
+			if (next == currentPage) {
+				nextText();
+			} else {
+				currentPage = next;
+				this.setURL(currentPage.toURL());
+			}
+			currentText = currentEdition.getText();
+		} else
+			firstPage();
+		//page_label.setText(makePageLabel());
+	}
+
+
+	public void firstText() {
+		//Text current = this.currentPage.getEdition().getText();
+		Corpus corpus = currentText.getCorpus();
+		Text firstText = corpus.getFirstText();
+
+		if (firstText != null) {
+			String editionName = currentEdition.getName();
+			Edition tmp = firstText.getEdition(editionName);
+			if (tmp == null) {
+				System.out.println(SynopticEditionUIMessages.EditionPanel_6+editionName+SynopticEditionUIMessages.EditionPanel_7+firstText.getName());
+				return;
+			}
+			currentEdition = tmp;
+			currentPage = currentEdition.getFirstPage(); 
+			currentText = firstText;
+			if (currentPage == null) {
+				StatusLine.setMessage("No previous text"); //$NON-NLS-1$
+				return;
+			}
+			this.setURL(currentPage.toURL());
+		}
+	}
+
+	/**
+	 * Next text.
+	 */
+	public void lastText() {
+		//Text current = this.currentPage.getEdition().getText();
+		Corpus b = currentText.getCorpus();
+		Text lastText = b.getLastText();
+
+		if (lastText != null) {
+			String editionName = currentEdition.getName();
+			Edition tmp = lastText.getEdition(editionName);
+			if (tmp == null) {
+				System.out.println(SynopticEditionUIMessages.EditionPanel_6+editionName+SynopticEditionUIMessages.EditionPanel_7+lastText.getName());
+				return;
+			}
+
+			currentEdition = tmp;
+			currentPage = currentEdition.getFirstPage(); 
+			currentText = lastText;
+			if (currentPage == null) {
+				StatusLine.setMessage("No text next"); //$NON-NLS-1$
+				return;
+			}
+
+			this.setURL(currentPage.toURL());
+			//page_label.setText(makePageLabel());
+		}
+		// System.out.println("Next texts "+nextText);
+	}
+
+	/**
+	 * Previous text.
+	 * @param fromNextText if true  it means the user was reading the next text and then we show the last page of the previous text
+	 */
+	public void previousText(boolean fromNextText) {
+
+		//Text current = this.currentPage.getEdition().getText();
+		Corpus corpus = currentText.getCorpus();
+		Text previousText = corpus.getPreviousText(currentText);
+
+		if (previousText != null) {
+			String editionName = currentEdition.getName();
+
+			Edition tmp = previousText.getEdition(editionName);
+			if (tmp == null) {
+				System.out.println(SynopticEditionUIMessages.EditionPanel_6+editionName+SynopticEditionUIMessages.EditionPanel_7+previousText.getName());
+			}
+			currentEdition = tmp;
+			currentText = previousText;
+			if (fromNextText) {
+				currentPage = currentEdition.getLastPage(); 
+			} else {
+				currentPage = currentEdition.getFirstPage(); 
+			}
+
+			if (currentPage == null) {
+				StatusLine.setMessage("No previous text"); //$NON-NLS-1$
+				return;
+			}
+			this.setURL(currentPage.toURL());
+		}
+		// System.out.println("Previous texts "+previousText);
+	}
+
+	/**
+	 * Next text.
+	 */
+	public void nextText() {
+		//Text current = this.currentPage.getEdition().getText();
+		Corpus b = currentText.getCorpus();
+		Text nextText = b.getNextText(currentText);
+
+		if (nextText != null) {
+			String editionName = currentEdition.getName();
+			Edition tmp = nextText.getEdition(editionName);
+			if (tmp == null) {
+				System.out.println(SynopticEditionUIMessages.EditionPanel_6+editionName+SynopticEditionUIMessages.EditionPanel_7+nextText.getName());
+				return;
+			}
+			currentEdition = tmp;
+
+			currentPage = currentEdition.getFirstPage(); 
+			currentText = nextText;
+			if (currentPage == null) {
+				StatusLine.setMessage("No text next"); //$NON-NLS-1$
+				return;
+			}
+
+			this.setURL(currentPage.toURL());
+			//page_label.setText(makePageLabel());
+		}
+		// System.out.println("Next texts "+nextText);
+	}
+
+
+	public void setText(Text text, boolean refresh) {
+		String editionName = currentEdition.getName();
+		Edition tmp = text.getEdition(editionName);
+		if (tmp == null) {
+			System.out.println(SynopticEditionUIMessages.EditionPanel_6+editionName+SynopticEditionUIMessages.EditionPanel_7+text.getName());
+			return;
+		}
+
+		currentEdition = tmp;
+		currentPage = currentEdition.getFirstPage(); 
+		currentText = text;
+		if (currentPage == null) {
+			StatusLine.setMessage("No text next"); //$NON-NLS-1$
+			return;
+		}
+
+		if (refresh) this.setURL(currentPage.toURL());
+		//page_label.setText(makePageLabel());
+	}
+
+	/**
+	 * Gets the current page.
+	 *
+	 * @return the current page
+	 */
+	public Page getCurrentPage() {
+		return currentPage;
+	}
+
+	/**
+	 * Gets the current text.
+	 *
+	 * @return the current page
+	 */
+	public Text getCurrentText() {
+		return currentText;
+	}
+
+	/**
+	 * Make page label.
+	 *
+	 * @return the string
+	 */
+	public String makePageLabel() {
+		return currentPage.getName()
+				+ " / " + currentPage.getEdition().getNumPages(); //$NON-NLS-1$
+	}
+
+	/**
+	 * Show page.
+	 *
+	 * @param page the page
+	 */
+	public void showPage(Page page) {
+		//System.out.println("SHOW PAGE "+page);
+		currentEdition = page.getEdition();
+		currentText = currentEdition.getText();
+		currentPage = page;
+		this.setURL(currentPage.toURL());
+	}
+
+	public void reloadPage() {
+		this.setURL(currentPage.toURL());
+	}
+
+	//	/**
+	//	 * Sets the edition.
+	//	 *
+	//	 * @param edition the new edition
+	//	 */
+	//	public void setEdition(Edition edition) {
+	//		this.currentEdition = edition;
+	//	}
+
+	static String SCRIPT01 = "var html = \"\";"+
+			"if (typeof window.getSelection != \"undefined\") {"+ // modern Web browsers
+			"var sel = window.getSelection();"+
+			"if (sel.rangeCount) {"+
+			"var container = document.createElement(\"div\");"+
+			"for (var i = 0, len = sel.rangeCount; i < len; ++i) {"+
+			"container.appendChild(sel.getRangeAt(i).cloneContents());"+
+			"}"+
+			"html = container.innerHTML;"+
+			"}"+
+			"} else if (typeof document.selection != \"undefined\") {"+ // for IE < 11
+			"if (document.selection.type == \"Text\") {"+
+			"html = document.selection.createRange().htmlText;"+
+			"}" +
+			"}" +
+			"return html";
+
+	public String getTextSelectionDOM() {
+		return ((String) evaluate(SCRIPT01));
+	}
+
+	public String[] getWordSelection() {
+
+		//System.out.println("getWordSelection");
+		String SCRIPT02_getspans = ""//functions
+				+"var all = [];"
+				+"\nvar sel = txmGetSelection();"
+				+"\nif (sel.rangeCount == 0) {return all;}"
+				//+"\nalert('sel='+sel);"
+				+"\nvar range = txmGetRange(sel, 0);"
+				//+"\nalert('range='+range);"
+				+"\nvar frag = txmGetFragment(range);"
+				//+"\nalert('frag='+frag);"
+				+"\nvar children = txmGetChildren(frag);"
+				//+"\nalert('children='+children);"
+				//+"\nalert('children.length='+children.length);"
+				+"\nif ((children.length == 0) || (children.length == 1 && children.item(0).nodeType == 3)) {"
+				+"\n	var parent = txmGetParentElementRange(range);"
+				//+"\n	if (parent instanceof HTMLHtmlElement) {alert('HTMLHtmlElement parent='+parent);return findIdsInString(parent, all);}"
+				+"\n	if (typeof parent.getAttribute == 'undefined') {return all}"
+				+"\n	var id = parent.getAttribute('id');"
+				+"\n	var id = parent.getAttribute('id');"
+				+"\n	if (txmGetTagName(parent) == 'SPAN' && id != null && id.indexOf('w_') == 0) {"
+				+"\n		all.push(id);"
+				+"\n	} else {" // try with the parent's parent 
+				+"\n		var parent = txmGetParent(parent);"
+				//+"\n		alert('text selection, parent='+txmGetTagName(parent))"
+				+"\n	if (typeof parent.getAttribute == 'undefined') {return all}"
+				+"\n		var id = parent.getAttribute('id');"
+				+"\n		if (txmGetTagName(parent) == 'SPAN' && id != null && id.indexOf('w_') == 0) {"
+				+"\n			all.push(id);"
+				+"\n		}"
+				+"\n	}"
+				+"\n} else {"
+				+"\n	findSpans(children, all);"
+				+"\n}"
+				//+"alert('result='+all)"
+				+"\nreturn all;";
+
+		//		System.out.println(functions);
+		//		System.out.println(SCRIPT02_getspans);
+
+		Object ret = evaluate(SCRIPT02_getspans);
+		if (ret instanceof Object[]) {
+			Log.info("selection word ids="+Arrays.toString((Object[])ret));
+			Object[] array = (Object[])ret;
+			String[] sel = new String[2];
+			if (array.length == 0) {
+				return null;
+			} else if (array.length == 1) {
+				sel[0] = array[0].toString();
+				return sel;
+			} else {
+				sel[0] = array[0].toString();
+				sel[1] = array[array.length-1].toString();
+				return sel;
+			}
+		} else { 
+			System.out.println("SCRIPT RETURNED="+ret);
+			return null;
+		}
+	}
+
+	public String getTextSelection() {
+		//System.out.println("DOM="+getTextSelectionDOM());
+		String rez =  getTextSelectionDOM().replaceAll("<[^>]+>", "");
+		//System.out.println("STR="+rez);
+		return rez;
+	}
+
+	@Override
+	public void addSelectionChangedListener(ISelectionChangedListener listener) {	}
+
+	@Override
+	public ISelection getSelection() {
+		return new SynopticTextSelection(this);
+	}
+
+	@Override
+	public void removeSelectionChangedListener(
+			ISelectionChangedListener listener) {	}
+
+	@Override
+	public void setSelection(ISelection selection) {	}
+
+	static public class SynopticTextSelection implements ISelection  {
+		String str;
+		public SynopticTextSelection(EditionPanel panel) {
+			this.str = panel.getTextSelection();
+		}
+
+		@Override
+		public boolean isEmpty() {
+			return str != null && str.length() > 0;
+		}
+
+		public String getTextSelection() {
+			return str;
+		}
+	}
+
+	public Edition getEdition() {
+		return currentEdition;
+	}
+
+	public MenuManager getMenuManager() {	
+		return menuManager;
+	}
+
+	public void initMenu() {
+		// create a new menu	
+		menuManager = new MenuManager(); //$NON-NLS-1$
+
+		Menu menu = menuManager.createContextMenu(this.getBrowser());
+
+		menu.addMenuListener(new MenuListener() {
+
+			@Override
+			public void menuShown(MenuEvent e) {
+				Menu menu = menuManager.getMenu();
+				if (menu == null) return;
+				new MenuItem(menu, SWT.SEPARATOR);
+
+				MenuItem copyItem = new MenuItem(menu, SWT.NONE);
+				copyItem.setText("Copy text selection");
+				copyItem.addSelectionListener(new SelectionListener() {
+
+					@Override
+					public void widgetSelected(SelectionEvent e) {
+						String text = EditionPanel.this.getTextSelection();
+						if (text != null && text.length() > 0) {
+							IOClipboard.write(text);
+						}
+					}
+
+					@Override
+					public void widgetDefaultSelected(SelectionEvent e) { }
+				});
+				String text = EditionPanel.this.getTextSelection();
+				copyItem.setEnabled(text != null && text.length() > 0);
+
+				MenuItem reloadItem = new MenuItem(menu, SWT.NONE);
+				reloadItem.setText("Reload");
+				reloadItem.addSelectionListener(new SelectionListener() {
+
+					@Override
+					public void widgetSelected(SelectionEvent e) {
+						EditionPanel.this.getBrowser().refresh();
+					}
+
+					@Override
+					public void widgetDefaultSelected(SelectionEvent e) { }
+				});
+				MenuItem backItem = new MenuItem(menu, SWT.NONE);
+				backItem.setText("Back");
+				backItem.addSelectionListener(new SelectionListener() {
+
+					@Override
+					public void widgetSelected(SelectionEvent e) {
+						EditionPanel.this.getBrowser().back();
+					}
+
+					@Override
+					public void widgetDefaultSelected(SelectionEvent e) { }
+				});
+				MenuItem forwardItem = new MenuItem(menu, SWT.NONE);
+				forwardItem.setText("Forward");
+				forwardItem.addSelectionListener(new SelectionListener() {
+
+					@Override
+					public void widgetSelected(SelectionEvent e) {
+						EditionPanel.this.getBrowser().forward();
+					}
+
+					@Override
+					public void widgetDefaultSelected(SelectionEvent e) { }
+				});
+			}
+
+			@Override
+			public void menuHidden(MenuEvent e) {
+				// TODO Auto-generated method stub
+
+			}
+		});
+		//		// restore old listeners
+		//		Menu origMenu = this.browser.getMenu();
+		//		if (origMenu != null) {
+		//			if (origMenu.getListeners(SWT.Hide) != null)
+		//				for (Listener listener : origMenu.getListeners(SWT.Hide)) menu.addListener(SWT.Hide, listener);
+		//			if (origMenu.getListeners(SWT.Show) != null)
+		//				for (Listener listener : origMenu.getListeners(SWT.Show)) menu.addListener(SWT.Show, listener);
+		//			for (MenuItem origItem : origMenu.getItems()) { // restore old menu items
+		//				MenuItem item = new MenuItem(menu, origItem.getStyle());
+		//				item.setText(origItem.getText());
+		//				item.setImage(origItem.getImage());
+		//				if (origItem.getListeners(SWT.Selection) != null && origItem.getListeners(SWT.Selection).length > 0)
+		//					item.addListener(SWT.Selection, origItem.getListeners(SWT.Selection)[0]);
+		//			}
+		//		}
+		// replace the menu
+		this.getBrowser().setMenu(menu); 
+	}
+
+	public void initSelectionProvider() {
+		selProvider = new ISelectionProvider() {
+			@Override
+			public void setSelection(ISelection selection) { }
+			@Override
+			public void removeSelectionChangedListener(ISelectionChangedListener listener) { }
+			@Override
+			public ISelection getSelection() {
+				ITextSelection sel = new ITextSelection() {
+					@Override
+					public boolean isEmpty() {return EditionPanel.this.getTextSelection().length() == 0;}
+					@Override
+					public String getText() {return EditionPanel.this.getTextSelection();}
+					@Override
+					public int getStartLine() {	return 0;}
+					@Override
+					public int getOffset() {return 0;}
+					@Override
+					public int getLength() {return 0;}
+					@Override
+					public int getEndLine() {return 0;}
+				};
+				return sel;
+			}
+
+			@Override
+			public void addSelectionChangedListener(ISelectionChangedListener listener) { }
+		};
+	}
+
+
+
+	public void goToPage(String name) {
+
+		Page next = currentEdition.get(name);
+		// System.out.println(Messages.TxmBrowser_4+currentPage);
+		if (next != null) {
+			currentPage = next;
+			this.setURL(currentPage.toURL());
+		} else {
+			System.out.println("Page not found ("+name+").");
+		}
+	}
+
+	public void setFocusedWordID(String focusid) {
+		this.focusedWordID = focusid;
+	}
+
+	public void setHighlightedArea(HashSet<int[]> positions) {
+		Log.info("Highlight area: not implemented");
+	}
+
+	public void expandSelectionTo(String[] ids) {
+		// expand selection
+
+		if (ids.length == 0) return;
+		//TODO: enable the feature for Windows computers
+		//if (System.getProperty("os.name").toLowerCase().contains("windows")) return; 
+
+		//this.getBrowser().evaluate("alert('expand selection');");
+		//System.out.println("EXPAND SELECTION TO "+Arrays.toString(ids));
+		String id1 = ids[0];
+		String id2 = ids[1];
+		if (id2 == null) id2 = id1;
+		String SCRIPT02_expand = ""
+				+ "var elt = document.getElementById(\""+id1+"\");\n"
+				+ "var elt2 = document.getElementById(\""+id2+"\");\n"
+				//+ "alert(\"elt=\"+elt);\n"
+				+ "var sel = txmGetSelection();\n"
+				//+ "alert(\"sel=\"+sel.extentNode);\n"
+				//+ "alert(\"typeof sel=\"+Object.getOwnPropertyNames(sel));\n"
+				//+ "alert(\"get_type sel=\"+get_type(sel));\n"
+				+ "var range = txmGetRange(sel, 0);\n"
+				//+ "alert(\"range=\"+range);\n"
+				//+ "alert(\"typeof range=\"+Object.getOwnPropertyNames(range));\n"
+				//+ "alert(\"get_type range=\"+get_type(range));\n"
+				+"range.setStart(elt, 0);\n"
+				+"range.setEndAfter(elt2, 0);\n"
+				+"sel.removeAllRanges();\n"
+				+"sel.addRange(range);\n"
+				+ "\n"
+				+ "return null;";
+
+		//System.out.println("Eval...\n"+SCRIPT02_expand);
+		evaluate(SCRIPT02_expand);
+		return;
+	}
+
+	public void addFontWeightWordsById(String weight, List<String> wordids) {
+		for (String wordid : wordids) {
+			addFontWeightWordsById(weight, wordid);
+		}
+	}
+
+	public void addFontWeightWordsById(String weight, String wordid) {
+		this.fontWeightPerWordIDS.put(wordid, weight);
+	}
+
+	public void removeFontWeightWordsById(String wordid) {
+		this.fontWeightPerWordIDS.remove(wordid);
+	}
+
+	public void removeFontWeightWordsById(List<String> wordids) {
+		for (String wordid : wordids) {
+			removeFontWeightWordsById(wordid);
+		}
+	}
+
+	// Called by JavaScript
+	public class CommandLink extends BrowserFunction {
+		String data = "";
+		Browser browser;
+		CommandLink (Browser browser) {
+			super (browser, "txmcommand");
+			this.browser = browser;
+		}
+		public Object function (Object[] arguments) {
+			HashMap<String, String> params = new HashMap<String, String>();
+			for (int i = 0 ; i < arguments.length ; i += 2) {
+				params.put(arguments[i].toString(), arguments[i+1].toString());
+			}
+
+
+			String id = params.get("id");
+			if (id != null) {
+				params.remove("id");
+				System.out.println("CALLING CMD with id="+id+" and parameters="+params);
+				//get the command from plugin.xml
+				IWorkbenchWindow window = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
+				ICommandService cmdService = (ICommandService)window.getService(ICommandService.class);
+				Command cmd = cmdService.getCommand(id);
+
+				//get the parameter
+				ArrayList<Parameterization> parameters = new ArrayList<Parameterization>();
+				for (String k : params.keySet()) {
+					try {
+						IParameter iparam = cmd.getParameter(k);
+						Parameterization p = new Parameterization(iparam, params.get(k));
+						parameters.add(p);
+					} catch (NotDefinedException e) {
+						System.out.println("warning: unknowned parameter id="+k);
+					}
+				}
+
+				//build the parameterized command
+				ParameterizedCommand pc = new ParameterizedCommand(cmd, parameters.toArray(new Parameterization[parameters.size()]));
+
+				//execute the command
+				IHandlerService handlerService = (IHandlerService)window.getService(IHandlerService.class);
+				try {
+					handlerService.executeCommand(pc, null);
+				} catch (Exception e) {
+					e.printStackTrace();
+				}
+			} else {
+				System.out.println("Cannot call txmcommand without 'id' parameter: "+params);
+			}
+			return arguments;
+		}
+	}
+
+	/**
+	 * Clear all highlighted words
+	 */
+	public void removeHighlightWords() {
+		Set<String> keys = highlightedColorPerWordIDS.keySet();
+		for (String key : keys) {
+			highlightedColorPerWordIDS.remove(key);
+		}
+	}
+}

